#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include "interface.h"
#define INTERFACE_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE((obj), TYPE_INTERFACE, InterfacePrivate))
enum {
	PROP_0,			/* unused property */
	PROP_ADDRESS,
	PROP_AUTO,
	PROP_BOOTPROTO,
	PROP_BROADCAST,
	PROP_DEBUG,
	PROP_DEV,
	PROP_ENABLED,
	PROP_FILE,
	PROP_GATEWAY,
	PROP_NAME,
	PROP_NETMASK,
	PROP_NETWORK,
	PROP_NOAUTH,
	PROP_PERSIST,
	PROP_SERIAL_HWCTL,
	PROP_SERIAL_PORT,
	PROP_SET_DEFAULT_GW,
	PROP_UPDATE_DNS,
	PROP_USER,
	PROP_WVSECTION,
	PROP_1			/* unused property */
};
struct _InterfacePrivate {
	gchar *address;
	gint auto;
	gchar *bootproto;
	gchar *broadcast;
	gchar *debug;
	gchar *dev;
	gint enabled;
	gchar *file;
	gchar *gateway;
	gchar *name;
	gchar *netmask;
	gchar *network;
	gchar *noauth;
	gchar *persist;
	gchar *serial_hwctl;
	gchar *serial_port;
	gchar *set_default_gw;
	gint update_dns;
	gint user;
	gchar *wvsection;
};				/* Parent class */
static GObjectClass *parent_class = NULL;
/* Prototypes definition */
static void interface_init(Interface * obj);
static void interface_class_init(InterfaceClass * obj);
static void interface_finalize(GObject * object);
static void interface_set_property(GObject * object, guint prop_id,
				   const GValue * value,
				   GParamSpec * pspec);
static void interface_get_property(GObject * object, guint prop_id,
				   GValue * value, GParamSpec * pspec);

GType interface_get_type(void)
{
	static GType object_type = 0;
	if (!object_type) {
		static const GTypeInfo object_info = {
			sizeof(InterfaceClass), NULL,	/* base init */
			NULL,	/* base finalize */
			(GClassInitFunc) interface_class_init,
			NULL,	/* class finalize */
			NULL,	/* class data */
			sizeof(Interface),
			0,	/* number of pre-allocs */
			(GInstanceInitFunc) interface_init,
		};
		object_type =
		    g_type_register_static(G_TYPE_OBJECT, "Interface",
					   &object_info, 0);
	}
	return object_type;
}

static void interface_class_init(InterfaceClass * klass)
{
	GObjectClass *gobject_class;
	parent_class = g_type_class_peek_parent(klass);
	gobject_class = G_OBJECT_CLASS(klass);
	gobject_class->finalize = interface_finalize;
	gobject_class->set_property = interface_set_property;
	gobject_class->get_property = interface_get_property;
	g_object_class_install_property(gobject_class,
					PROP_ADDRESS,
					g_param_spec_string("address",
							    "address",
							    "address",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_AUTO,
					g_param_spec_int("auto", "auto",
							 "auto", G_MININT,
							 G_MAXINT, 0,
							 G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_BOOTPROTO,
					g_param_spec_string("bootproto",
							    "bootproto",
							    "bootproto",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_BROADCAST,
					g_param_spec_string("broadcast",
							    "broadcast",
							    "broadcast",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_DEBUG,
					g_param_spec_string("debug",
							    "debug",
							    "debug", NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_DEV,
					g_param_spec_string("dev", "dev",
							    "dev", NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_ENABLED,
					g_param_spec_int("enabled",
							 "enabled",
							 "enabled",
							 G_MININT,
							 G_MAXINT, 0,
							 G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_FILE,
					g_param_spec_string("file", "file",
							    "file", NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_GATEWAY,
					g_param_spec_string("gateway",
							    "gateway",
							    "gateway",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_NAME,
					g_param_spec_string("name", "name",
							    "name", NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_NETMASK,
					g_param_spec_string("netmask",
							    "netmask",
							    "netmask",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_NETWORK,
					g_param_spec_string("network",
							    "network",
							    "network",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_NOAUTH,
					g_param_spec_string("noauth",
							    "noauth",
							    "noauth", NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_PERSIST,
					g_param_spec_string("persist",
							    "persist",
							    "persist",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_SERIAL_HWCTL,
					g_param_spec_string("serial_hwctl",
							    "serial_hwctl",
							    "serial_hwctl",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_SERIAL_PORT,
					g_param_spec_string("serial_port",
							    "serial_port",
							    "serial_port",
							    NULL,
							    G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_SET_DEFAULT_GW,
					g_param_spec_string
					("set_default_gw",
					 "set_default_gw",
					 "set_default_gw", NULL,
					 G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_UPDATE_DNS,
					g_param_spec_int("update_dns",
							 "update_dns",
							 "update_dns",
							 G_MININT,
							 G_MAXINT, 0,
							 G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_USER,
					g_param_spec_int("user", "user",
							 "user", G_MININT,
							 G_MAXINT, 0,
							 G_PARAM_READWRITE));
	g_object_class_install_property(gobject_class, PROP_WVSECTION,
					g_param_spec_string("wvsection",
							    "wvsection",
							    "wvsection",
							    NULL,
							    G_PARAM_READWRITE));
	g_type_class_add_private(gobject_class, sizeof(InterfacePrivate));
}

static void interface_init(Interface * object)
{
	object->private_data = INTERFACE_GET_PRIVATE(object);
	object->private_data->address = NULL;
	object->private_data->bootproto = NULL;
	object->private_data->broadcast = NULL;
	object->private_data->debug = NULL;
	object->private_data->dev = NULL;
	object->private_data->file = NULL;
	object->private_data->gateway = NULL;
	object->private_data->name = NULL;
	object->private_data->netmask = NULL;
	object->private_data->network = NULL;
	object->private_data->noauth = NULL;
	object->private_data->persist = NULL;
	object->private_data->serial_hwctl = NULL;
	object->private_data->serial_port = NULL;
	object->private_data->set_default_gw = NULL;
	object->private_data->wvsection = NULL;
}

static void
interface_set_property(GObject * object, guint prop_id,
		       const GValue * value, GParamSpec * pspec)
{
	Interface *self;
	gchar tmp;
	self = INTERFACE(object);
	switch (prop_id) {
	case PROP_ADDRESS:
		interface_set_address(self, g_value_get_string(value));
		break;
	case PROP_AUTO:
		interface_set_auto(self, g_value_get_int(value));
		break;
	case PROP_BOOTPROTO:
		interface_set_bootproto(self, g_value_get_string(value));
		break;
	case PROP_BROADCAST:
		interface_set_broadcast(self, g_value_get_string(value));
		break;
	case PROP_DEBUG:
		interface_set_debug(self, g_value_get_string(value));
		break;
	case PROP_DEV:
		interface_set_dev(self, g_value_get_string(value));
		break;
	case PROP_ENABLED:
		interface_set_enabled(self, g_value_get_int(value));
		break;
	case PROP_FILE:
		interface_set_file(self, g_value_get_string(value));
		break;
	case PROP_GATEWAY:
		interface_set_gateway(self, g_value_get_string(value));
		break;
	case PROP_NAME:
		interface_set_name(self, g_value_get_string(value));
		break;
	case PROP_NETMASK:
		interface_set_netmask(self, g_value_get_string(value));
		break;
	case PROP_NETWORK:
		interface_set_network(self, g_value_get_string(value));
		break;
	case PROP_NOAUTH:
		interface_set_noauth(self, g_value_get_string(value));
		break;
	case PROP_PERSIST:
		interface_set_persist(self, g_value_get_string(value));
		break;
	case PROP_SERIAL_HWCTL:
		interface_set_serial_hwctl(self,
					   g_value_get_string(value));
		break;
	case PROP_SERIAL_PORT:
		interface_set_serial_port(self, g_value_get_string(value));
		break;
	case PROP_SET_DEFAULT_GW:
		interface_set_set_default_gw(self,
					     g_value_get_string(value));
		break;
	case PROP_UPDATE_DNS:
		interface_set_update_dns(self, g_value_get_int(value));
		break;
	case PROP_USER:
		interface_set_user(self, g_value_get_int(value));
		break;
	case PROP_WVSECTION:
		interface_set_wvsection(self, g_value_get_string(value));
		break;
	default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
		break;
	}
}

static void
interface_get_property(GObject * object, guint prop_id, GValue * value,
		       GParamSpec * pspec)
{
	Interface *self;
	self = INTERFACE(object);
	switch (prop_id) {
	case PROP_ADDRESS:
		g_value_set_string(value, interface_get_address(self));
		break;
	case PROP_AUTO:
		g_value_set_int(value, interface_get_auto(self));
		break;
	case PROP_BOOTPROTO:
		g_value_set_string(value, interface_get_bootproto(self));
		break;
	case PROP_BROADCAST:
		g_value_set_string(value, interface_get_broadcast(self));
		break;
	case PROP_DEBUG:
		g_value_set_string(value, interface_get_debug(self));
		break;
	case PROP_DEV:
		g_value_set_string(value, interface_get_dev(self));
		break;
	case PROP_ENABLED:
		g_value_set_int(value, interface_get_enabled(self));
		break;
	case PROP_FILE:
		g_value_set_string(value, interface_get_file(self));
		break;
	case PROP_GATEWAY:
		g_value_set_string(value, interface_get_gateway(self));
		break;
	case PROP_NAME:
		g_value_set_string(value, interface_get_name(self));
		break;
	case PROP_NETMASK:
		g_value_set_string(value, interface_get_netmask(self));
		break;
	case PROP_NETWORK:
		g_value_set_string(value, interface_get_network(self));
		break;
	case PROP_NOAUTH:
		g_value_set_string(value, interface_get_noauth(self));
		break;
	case PROP_PERSIST:
		g_value_set_string(value, interface_get_persist(self));
		break;
	case PROP_SERIAL_HWCTL:
		g_value_set_string(value,
				   interface_get_serial_hwctl(self));
		break;
	case PROP_SERIAL_PORT:
		g_value_set_string(value, interface_get_serial_port(self));
		break;
	case PROP_SET_DEFAULT_GW:
		g_value_set_string(value,
				   interface_get_set_default_gw(self));
		break;
	case PROP_UPDATE_DNS:
		g_value_set_int(value, interface_get_update_dns(self));
		break;
	case PROP_USER:
		g_value_set_int(value, interface_get_user(self));
		break;
	case PROP_WVSECTION:
		g_value_set_string(value, interface_get_wvsection(self));
		break;
	default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
	}
}

Interface *interface_new(void)
{
	Interface *ret;
	ret = g_object_new(TYPE_INTERFACE, NULL);
	g_assert(ret);
	return ret;
}

static void interface_finalize(GObject * object)
{
	Interface *self;
	GList *list;
	self = INTERFACE(object);
	g_free(self->private_data->address);
	g_free(self->private_data->bootproto);
	g_free(self->private_data->broadcast);
	g_free(self->private_data->debug);
	g_free(self->private_data->dev);
	g_free(self->private_data->file);
	g_free(self->private_data->gateway);
	g_free(self->private_data->name);
	g_free(self->private_data->netmask);
	g_free(self->private_data->network);
	g_free(self->private_data->noauth);
	g_free(self->private_data->persist);
	g_free(self->private_data->serial_hwctl);
	g_free(self->private_data->serial_port);
	g_free(self->private_data->set_default_gw);
	g_free(self->private_data->wvsection);
}

/* Converts this object to a xml representation.
 * If "parent_node" is NULL it the returned node is new the document root.
 * Returns the root node of the current object.
 */
xmlNodePtr interface_to_xml(Interface * self, xmlDocPtr doc,
			    xmlNodePtr parent_node)
{
	xmlNodePtr node;
	gchar *data;
	node = xmlNewNode(NULL, "interface");
	if (!parent_node) {
		xmlDocSetRootElement(doc, node);
	} else {
		xmlAddChild(parent_node, node);
	}
	parent_node = node;
	data = (gchar *) interface_get_address(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "address", data);
	}
	data = g_strdup_printf("%d", interface_get_auto(self));
	if (data) {
		node = xmlNewChild(parent_node, NULL, "auto", data);
		g_free(data);
	}
	data = (gchar *) interface_get_bootproto(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "bootproto", data);
	}
	data = (gchar *) interface_get_broadcast(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "broadcast", data);
	}
	data = (gchar *) interface_get_debug(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "debug", data);
	}
	data = (gchar *) interface_get_dev(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "dev", data);
	}
	data = g_strdup_printf("%d", interface_get_enabled(self));
	if (data) {
		node = xmlNewChild(parent_node, NULL, "enabled", data);
		g_free(data);
	}
	data = (gchar *) interface_get_file(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "file", data);
	}
	data = (gchar *) interface_get_gateway(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "gateway", data);
	}
	data = (gchar *) interface_get_name(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "name", data);
	}
	data = (gchar *) interface_get_netmask(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "netmask", data);
	}
	data = (gchar *) interface_get_network(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "network", data);
	}
	data = (gchar *) interface_get_noauth(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "noauth", data);
	}
	data = (gchar *) interface_get_persist(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "persist", data);
	}
	data = (gchar *) interface_get_serial_hwctl(self);
	if (data) {
		node =
		    xmlNewChild(parent_node, NULL, "serial_hwctl", data);
	}
	data = (gchar *) interface_get_serial_port(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "serial_port", data);
	}
	data = (gchar *) interface_get_set_default_gw(self);
	if (data) {
		node =
		    xmlNewChild(parent_node, NULL, "set_default_gw", data);
	}
	data = g_strdup_printf("%d", interface_get_update_dns(self));
	if (data) {
		node = xmlNewChild(parent_node, NULL, "update_dns", data);
		g_free(data);
	}
	data = g_strdup_printf("%d", interface_get_user(self));
	if (data) {
		node = xmlNewChild(parent_node, NULL, "user", data);
		g_free(data);
	}
	data = (gchar *) interface_get_wvsection(self);
	if (data) {
		node = xmlNewChild(parent_node, NULL, "wvsection", data);
	}
	return parent_node;
}

Interface *interface_new_from_xml(xmlNodePtr node)
{
	Interface *ret;
	xmlNodePtr iter;
	g_assert(!strcmp("interface", node->name));
	ret = interface_new();
	for (iter = node->children; iter != NULL; iter = iter->next) {
		gchar *content = xmlNodeGetContent(iter);
		if (content) {
			if (!strcmp(iter->name, "address")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "address", val,
					     NULL);
			}
			if (!strcmp(iter->name, "auto")) {
				gint val = atoi(content);
				g_object_set(G_OBJECT(ret), "auto", val,
					     NULL);
			}
			if (!strcmp(iter->name, "bootproto")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "bootproto",
					     val, NULL);
			}
			if (!strcmp(iter->name, "broadcast")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "broadcast",
					     val, NULL);
			}
			if (!strcmp(iter->name, "debug")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "debug", val,
					     NULL);
			}
			if (!strcmp(iter->name, "dev")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "dev", val,
					     NULL);
			}
			if (!strcmp(iter->name, "enabled")) {
				gint val = atoi(content);
				g_object_set(G_OBJECT(ret), "enabled", val,
					     NULL);
			}
			if (!strcmp(iter->name, "file")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "file", val,
					     NULL);
			}
			if (!strcmp(iter->name, "gateway")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "gateway", val,
					     NULL);
			}
			if (!strcmp(iter->name, "name")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "name", val,
					     NULL);
			}
			if (!strcmp(iter->name, "netmask")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "netmask", val,
					     NULL);
			}
			if (!strcmp(iter->name, "network")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "network", val,
					     NULL);
			}
			if (!strcmp(iter->name, "noauth")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "noauth", val,
					     NULL);
			}
			if (!strcmp(iter->name, "persist")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "persist", val,
					     NULL);
			}
			if (!strcmp(iter->name, "serial_hwctl")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "serial_hwctl",
					     val, NULL);
			}
			if (!strcmp(iter->name, "serial_port")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "serial_port",
					     val, NULL);
			}
			if (!strcmp(iter->name, "set_default_gw")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret),
					     "set_default_gw", val, NULL);
			}
			if (!strcmp(iter->name, "update_dns")) {
				gint val = atoi(content);
				g_object_set(G_OBJECT(ret), "update_dns",
					     val, NULL);
			}
			if (!strcmp(iter->name, "user")) {
				gint val = atoi(content);
				g_object_set(G_OBJECT(ret), "user", val,
					     NULL);
			}
			if (!strcmp(iter->name, "wvsection")) {
				gchar *val = content;
				g_object_set(G_OBJECT(ret), "wvsection",
					     val, NULL);
			}
			xmlFree(content);
		}
	}
	return ret;
}
const gchar *interface_get_address(Interface * self)
{
	g_assert(self);
	return self->private_data->address;
}

void interface_set_address(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->address);
	self->private_data->address = tmp;
} gint interface_get_auto(Interface * self)
{
	g_assert(self);
	return self->private_data->auto;
}

void interface_set_auto(Interface * self, gint data)
{
	g_assert(self);
	self->private_data->auto = data;
} const gchar *interface_get_bootproto(Interface * self)
{
	g_assert(self);
	return self->private_data->bootproto;
}

void interface_set_bootproto(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->bootproto);
	self->private_data->bootproto = tmp;
} const gchar *interface_get_broadcast(Interface * self)
{
	g_assert(self);
	return self->private_data->broadcast;
}

void interface_set_broadcast(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->broadcast);
	self->private_data->broadcast = tmp;
} const gchar *interface_get_debug(Interface * self)
{
	g_assert(self);
	return self->private_data->debug;
}

void interface_set_debug(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->debug);
	self->private_data->debug = tmp;
} const gchar *interface_get_dev(Interface * self)
{
	g_assert(self);
	return self->private_data->dev;
}

void interface_set_dev(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->dev);
	self->private_data->dev = tmp;
} gint interface_get_enabled(Interface * self)
{
	g_assert(self);
	return self->private_data->enabled;
}

void interface_set_enabled(Interface * self, gint data)
{
	g_assert(self);
	self->private_data->enabled = data;
} const gchar *interface_get_file(Interface * self)
{
	g_assert(self);
	return self->private_data->file;
}

void interface_set_file(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->file);
	self->private_data->file = tmp;
} const gchar *interface_get_gateway(Interface * self)
{
	g_assert(self);
	return self->private_data->gateway;
}

void interface_set_gateway(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->gateway);
	self->private_data->gateway = tmp;
} const gchar *interface_get_name(Interface * self)
{
	g_assert(self);
	return self->private_data->name;
}

void interface_set_name(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->name);
	self->private_data->name = tmp;
} const gchar *interface_get_netmask(Interface * self)
{
	g_assert(self);
	return self->private_data->netmask;
}

void interface_set_netmask(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->netmask);
	self->private_data->netmask = tmp;
} const gchar *interface_get_network(Interface * self)
{
	g_assert(self);
	return self->private_data->network;
}

void interface_set_network(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->network);
	self->private_data->network = tmp;
} const gchar *interface_get_noauth(Interface * self)
{
	g_assert(self);
	return self->private_data->noauth;
}

void interface_set_noauth(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->noauth);
	self->private_data->noauth = tmp;
} const gchar *interface_get_persist(Interface * self)
{
	g_assert(self);
	return self->private_data->persist;
}

void interface_set_persist(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->persist);
	self->private_data->persist = tmp;
} const gchar *interface_get_serial_hwctl(Interface * self)
{
	g_assert(self);
	return self->private_data->serial_hwctl;
}

void interface_set_serial_hwctl(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->serial_hwctl);
	self->private_data->serial_hwctl = tmp;
} const gchar *interface_get_serial_port(Interface * self)
{
	g_assert(self);
	return self->private_data->serial_port;
}

void interface_set_serial_port(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->serial_port);
	self->private_data->serial_port = tmp;
} const gchar *interface_get_set_default_gw(Interface * self)
{
	g_assert(self);
	return self->private_data->set_default_gw;
}

void interface_set_set_default_gw(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->set_default_gw);
	self->private_data->set_default_gw = tmp;
} gint interface_get_update_dns(Interface * self)
{
	g_assert(self);
	return self->private_data->update_dns;
}

void interface_set_update_dns(Interface * self, gint data)
{
	g_assert(self);
	self->private_data->update_dns = data;
} gint interface_get_user(Interface * self)
{
	g_assert(self);
	return self->private_data->user;
}

void interface_set_user(Interface * self, gint data)
{
	g_assert(self);
	self->private_data->user = data;
} const gchar *interface_get_wvsection(Interface * self)
{
	g_assert(self);
	return self->private_data->wvsection;
}

void interface_set_wvsection(Interface * self, const gchar * data)
{
	gchar *tmp = (gchar *) g_strdup(data);
	g_assert(self);
	g_free(self->private_data->wvsection);
	self->private_data->wvsection = tmp;
}
